//NETLIST.CPP
#include "stdafx.h"
#include "NL.h"

#include "PartLib.h"
#include "BSchObj.h"
#include "BSchLine.h"
#include "BSchDash.h"
#include "BSchWire.h"
#include "BSchBus.h"
#include "BSchJunc.h"
#include "BSchPart.h"
#include "BSchTag.h"
#include "BSchLbl.h"
#include "BSchCmnt.h"
#include "BSchEntr.h"
#include "BSchPin.h"

#include "BSchData.h"
#include "NetList.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static BOOL s_TestJoint(long* pal,long* par,long bl,long br)
{
	int n;
	int al,ar;

	al = *pal;
	ar = *par;

	// L<R ۏ؂B
	// BSch̃f[^ł͂̂悤ɂȂĂ͂Ȃ̂ŏ璷Ȃ
	if(al > ar){
		n=al;
		al = ar;
		ar = n;
	}
	if(bl > br){
		n=bl;
		bl = br;
		br = n;
	}

	if(ar < bl) return FALSE;//  al----ar  []   bl----br
	if(br < al) return FALSE;//  bl----br  []   al----ar

	if(al > bl) al=bl;
	if(ar < br) ar=br;
	*pal = al;
	*par = ar;
	return TRUE;
}

//C[̘A
//܂͐̃C[݂̂Ώ
static void s_JointWire(CPtrList* pListWire)
{
	//
	POSITION pos;	
	CBSchWire* pObj;
	CPoint p0;
	CPoint p1;

	//Ώ
	POSITION pos2;
	POSITION posOld;	//IuWFNg̏p
	CBSchWire* pObj2;
	CPoint p20;
	CPoint p21;
	

	BOOL fH;	//tO
	
	BOOL fChange=TRUE;
	while(fChange){
		TRACE("s_JointWire() LOOP\n");
		fChange=FALSE;
		pos=pListWire->GetHeadPosition();
		while(pos){
			BOOL fJoint=FALSE;
			pObj=(CBSchWire*)pListWire->GetAt(pos);
			p0=pObj->GetPoint();
			p1=pObj->GetPoint1();
			if(p0.y==p1.y){		//Ȃ
				fH = TRUE;
			}else{
				if(p0.x!=p1.x){	//łȂ
					pListWire->GetNext(pos);	//posЂƂi߂
					continue;					//continue
				}
				fH = FALSE;
			}
			//Ał̂
			pos2=pos;
			pListWire->GetNext(pos2);//posЂƂi߂Ă
			while(pos2){
				posOld = pos2;
				pObj2=(CBSchWire*)pListWire->GetNext(pos2);
				p20=pObj2->GetPoint();
				p21=pObj2->GetPoint1();
				if(fH){
					if(p20.y!=p21.y || p0.y != p20.y) continue;
					if(s_TestJoint(&(p0.x),&(p1.x),p20.x,p21.x)){
						fJoint=TRUE;
						delete pObj2;
						pListWire->RemoveAt(posOld);
					}
				}else{
					if(p20.x!=p21.x || p0.x != p20.x) continue;
					if(s_TestJoint(&(p0.y),&(p1.y),p20.y,p21.y)){
						fJoint=TRUE;
						delete pObj2;
						pListWire->RemoveAt(posOld);
					}
				}
			}
			if(fJoint){
				pObj->SetPoint(&p0);
				pObj->SetPoint1(&p1);
				fChange=TRUE;
			}
			pListWire->GetNext(pos);
		}
	}
}

//C[ڍ_ŕ
//܂͐̃C[݂̂Ώ
static void s_DivideWire(CPtrList* pListWire,CPtrList* pListJunction)
{
	POSITION posJ;
	CBSchJunc* pJ;
	POSITION posW;
	CBSchWire* pW;
	CBSchWire* pWNew;
	CPoint point;
	

	posJ = pListJunction->GetHeadPosition();
	while(posJ){
		pJ = (CBSchJunc*)pListJunction->GetNext(posJ);
		point = pJ->GetPoint();
		posW = pListWire->GetHeadPosition();
		while(posW){
			pW = (CBSchWire*)pListWire->GetAt(posW);
			pWNew = pW->Divide(&point);
			if(pWNew) pListWire->AddTail((void*)pWNew);
			pListWire->GetNext(posW);
		}
	}
}


//diɐɖO
static void NameFromPowerPart(CPtrList* pListWire,CPtrList* pListPin,CPtrList* pListPowerPart)
{
	POSITION posP;
	CBSchPart* pP;
	POSITION pos;
	CBSchWire* pW;
	CBSchPin* pPin;

	CPoint p0;
	CPoint p1;
	CPoint point;
	LPCSTR pszName;
	int nPinCount;
	int i;


	posP = pListPowerPart->GetHeadPosition();
	while(posP){
		pP = (CBSchPart*)pListPowerPart->GetNext(posP);
		pszName = pP->GetName();//Ɏg߂ɕi𓾂
		if(!pszName || pszName[0] == 0){//i󔒂...
			pszName = pP->GetPartIndex()->GetName(NULL);//ɃCuig
		}
		nPinCount=pP->GetPinCount();
		TRACE("NameFromPowerPart() nPinCount - %d\n",nPinCount);
		for(i=0;i<nPinCount;i++){
			pP->GetPinPosition(i,&point);
			pos = pListWire->GetHeadPosition();
			while(pos){
				pW = (CBSchWire*)pListWire->GetNext(pos); 
				p0 = pW->GetPoint();
				p1 = pW->GetPoint1();
				if(point == p0 || point == p1){
					TRACE("NameFromPowerPart() Named - %s\n",pszName);
					pW->m_listSigName.AddTail(pszName);
				}
			}
			pos = pListPin->GetHeadPosition();
			while(pos){
				pPin = (CBSchPin*)pListPin->GetNext(pos); 
				if(point == pPin->m_point){
					TRACE("NameFromPowerPart() Named - %s\n",pszName);
					pPin->m_listSigName.AddTail(pszName);
				}
			}
		}
	}
}

//^Oɐƃsɐǉ
static void NameFromTag(CPtrList* pListWire,CPtrList* pListPin,CPtrList* pListTag)
{
	POSITION posS;
	CBSchTag* pS;
	POSITION pos;
	CBSchWire* pW;
	CBSchPin* pPin;

	CPoint p0;
	CPoint p1;
	CPoint point;
	LPCSTR pszName;
	int nPinCount;
	int i;


	posS = pListTag->GetHeadPosition();
	while(posS){
		pS = (CBSchTag*)pListTag->GetNext(posS);
		pszName = pS->GetName();//Ɏg߂Ƀ^O𓾂
		if(!pszName || pszName[0] == 0) continue;
		nPinCount=pS->GetPinCount();
		TRACE("NameFromTag() nPinCount - %d\n",nPinCount);
		for(i=0;i<nPinCount;i++){
			pS->GetPinPosition(i,&point);
			pos = pListWire->GetHeadPosition();
			while(pos){
				pW = (CBSchWire*)pListWire->GetNext(pos); 
				p0 = pW->GetPoint();
				p1 = pW->GetPoint1();
				if(point == p0 || point == p1){
					TRACE("NameFromTag() Named - %s\n",pszName);
					pW->m_listSigName.AddTail(pszName);
				}
			}
			pos = pListPin->GetHeadPosition();
			while(pos){
				pPin = (CBSchPin*)pListPin->GetNext(pos); 
				if(point == pPin->m_point){
					TRACE("NameFromTag() Named - %s\n",pszName);
					pPin->m_listSigName.AddTail(pszName);
				}
			}
		}
	}
}

//xɐɐǉ
static void NameFromLabel(CPtrList* pListWire,CPtrList* pListLabel)
{
	POSITION posS;
	CBSchLabel* pS;
	POSITION pos;
	CBSchWire* pW;

	CPoint p0;
	CPoint p1;
	CPoint point;
	LPCSTR pszName;
	BOOL fV;

	posS = pListLabel->GetHeadPosition();
	while(posS){
		pS = (CBSchLabel*)pListLabel->GetNext(posS);
		pszName = pS->GetName();//Ɏg߂Ƀx𓾂
		if(!pszName || pszName[0] == 0) continue;
		fV = pS->IsVertical();
		point = pS->GetPoint();
		TRACE("NameFromLabel() %s (%d,%d)\n",pszName,point.x,point.y);
		pos = pListWire->GetHeadPosition();
		while(pos){
			pW = (CBSchWire*)pListWire->GetNext(pos); 
			p0 = pW->GetPoint();
			p1 = pW->GetPoint1();
			if(fV){
				if( point.x!=p0.x || p0.x!=p1.x )continue;
				if(   point.y >= p0.y && point.y <= p1.y 
				   || point.y <= p0.y && point.y >= p1.y )
					pW->m_listSigName.AddTail(pszName);
			}else{
				if( point.y!=p0.y || p0.y!=p1.y )continue;
				if(   point.x >= p0.x && point.x <= p1.x 
				   || point.x <= p0.x && point.x >= p1.x )
					pW->m_listSigName.AddTail(pszName);
			}
		}
	}
}




//iԍiĂ̂폜B
//iԍŕiقȂ镔i폜
static void s_DeleteDuplicatePart(CPtrList* plistPart)
{
	POSITION pos0;
	CBSchPart* pP0;
	LPCSTR pszName0;
	LPCSTR pszNum0;
	POSITION pos1;
	CBSchPart* pP1;
	POSITION posOld;
	

	//iԍiĂ̂폜
	pos0 = plistPart->GetHeadPosition();
	while(pos0){
		posOld=pos0;
		pP0 = (CBSchPart*)plistPart->GetNext(pos0);
		pszName0 = pP0->GetName();
		pszNum0  = pP0->GetNum();
		if(!pszName0 || pszName0[0]==0 || !pszNum0 || pszNum0[0]==0){
			delete pP0;
			plistPart->RemoveAt(posOld);
		}
	}
	
	//iԍŕiقȂ镔i폜
	pos0 = plistPart->GetHeadPosition();
	while(pos0){
		pP0 = (CBSchPart*)plistPart->GetAt(pos0);
		pszName0 = pP0->GetName();
		pszNum0  = pP0->GetNum();
		//iԍŕiقȂ镔ič폜
		pos1=pos0;
		plistPart->GetNext(pos1);
		while(pos1){
			posOld=pos1;
			pP1 = (CBSchPart*)plistPart->GetNext(pos1);
			if(    lstrcmp(pszNum0 ,pP1->GetNum() )==0
				&& lstrcmp(pszName0,pP1->GetName())!=0 ){
				delete pP1;
				plistPart->RemoveAt(posOld);
			}
		}
		plistPart->GetNext(pos0);
	}
}


//Lȕĩs񋓂
static void s_EnumPin(CPtrList* plistPart,CPtrList* plistPin)
{
	POSITION pos;
	CBSchPart* pPart;
	LPCSTR pszPartNum;
	CPoint point;
	int nPinCount;
	int i;
	int nBlock;

	pos = plistPart->GetHeadPosition();
	while(pos){
		pPart = (CBSchPart*)plistPart->GetNext(pos);
		pszPartNum  = pPart->GetNum();
		nPinCount = pPart->GetPinCount();
		nBlock = pPart->GetBlock();
		for(i=0;i<nPinCount;i++){
			//char sz[32];
			//char* pc;
			//lbgX^gs`𐶐
			CBSchPin* pBSchPin = new CBSchPin;
			//io^
			pBSchPin->m_strPartNum = pPart->GetNum();
			//sԍDWORD`琶ēo^
			//DWORD dwPinNum = pPart->GetPinNum(i,nBlock);
			//pc=sz;
			//*pc=(char)(((dwPinNum & 0x7F0000)>>16) & 0xFF);
			//if(*pc){
			//	pc++;		//Version 0.61 pvtBbNX+0ȂA0\ȂBƔœIdlB
			//	if( (dwPinNum & 0x1FF) ==0 ){
			//		*pc=0;
			//	}else{
			//		_itoa(dwPinNum & 0x1FF,pc,10);
			//	}
			//}else{
			//	_itoa(dwPinNum & 0x1FF,pc,10);
			//}
			//pBSchPin->m_strPinNum = sz;
			const char* pszPinNum = pPart->GetPinNum(i,nBlock);
			if(pszPinNum!=NULL && *pszPinNum!='\0'){
				pBSchPin->m_strPinNum = pszPinNum+1;
			}else{
				pBSchPin->m_strPinNum ="";
			}
			//sʒuo^
			pPart->GetPinPosition(i,&point);
			pBSchPin->m_point = point;

			//TRACE("%s.%s  (%d,%d)\n",pBSchPin->m_strPartNum,pBSchPin->m_strPinNum,pBSchPin->m_point.x,pBSchPin->m_point.y);

			//sǗ郊Xgɒǉ
			plistPin->AddTail((void*)pBSchPin);
		}
	}
}



class CNLPinName{
public:
	CString m_strPartNum;
	CString m_strPinNum;
};


static CStringList	s_slSignalName;		//ݐM
static CStringList	s_slNewSignalName;	//VKM
//static CStringList	s_slPinName;		//̃lbg̃s
static CPtrList		s_listPinName;		//̃lbg̃s
static CPtrList		s_listPoint;		//ݍW
static CPtrList		s_listNewPoint;		//VKW

//̃lbg̃s̖O̓o^
static void AddToPinNameList(LPCSTR pszPartNum,LPCSTR pszPinNum)
{
	CNLPinName* pPinName = new CNLPinName;
	pPinName->m_strPartNum = pszPartNum;
	pPinName->m_strPinNum  = pszPinNum;
	s_listPinName.AddTail(pPinName);
}


static void s_ClearLocalList()
{
	POSITION pos;
	s_slSignalName.RemoveAll();
	s_slNewSignalName.RemoveAll();
//	s_slPinName.RemoveAll();
	
	pos = s_listPinName.GetHeadPosition();
	while(pos){
		CNLPinName* pp=(CNLPinName*)s_listPinName.GetNext(pos);
		delete pp;
	}
	s_listPinName.RemoveAll();

	pos = s_listPoint.GetHeadPosition();
	while(pos){
		CPoint* pp=(CPoint*)s_listPoint.GetNext(pos);
		delete pp;
	}
	s_listPoint.RemoveAll();

	pos = s_listNewPoint.GetHeadPosition();
	while(pos){
		CPoint* pp=(CPoint*)s_listNewPoint.GetNext(pos);
		delete pp;
	}
	s_listNewPoint.RemoveAll();

}


//w蕶s_slNewSignalName  s_slSignalNameɑ݂邩ǂ̃eXg
static BOOL IsNewSignalName(LPCSTR pszName)
{
	POSITION pos;
	
	CString str;
	pos=s_slSignalName.GetHeadPosition();
	while(pos){
		str=s_slSignalName.GetNext(pos);
		if(lstrcmp(str,pszName)==0) return FALSE;	//ϐMɑ
	}
	pos=s_slNewSignalName.GetHeadPosition();
	while(pos){
		str=s_slNewSignalName.GetNext(pos);
		if(lstrcmp(str,pszName)==0) return FALSE;	//VKMɑ
	}
	return TRUE;
}

//wWs_listNewPoint  s_listPointɑ݂邩ǂ̃eXg
static BOOL IsNewPoint(POINT* pPoint)
{
	POSITION pos;
	
	CPoint* pP;
	pos=s_listPoint.GetHeadPosition();
	while(pos){
		pP=(CPoint*)s_listPoint.GetNext(pos);
		if(*pP == *pPoint) return FALSE;	//ύWɑ
	}
	pos=s_listNewPoint.GetHeadPosition();
	while(pos){
		pP=(CPoint*)s_listNewPoint.GetNext(pos);
		if(*pP == *pPoint) return FALSE;	//Wɑ
	}
	return TRUE;
}



//lbgo
BOOL NetList1(CPtrList* plistWire,CPtrList* plistPin)
{
	CBSchWire* pWire;
	CBSchPin* pPin;
	CPoint* pPoint;

	
	//char sz[32];
	POSITION pos;
	POSITION posOld;
	POSITION pos2;

	
	//TRACE("NetList1() Start\n");
	//s̃XgsЂƂo
	pos = plistPin->GetHeadPosition();
	if(!pos) return FALSE;	//sȂΉɖ߂
	//os͌̃Xg s_slPinName ɖOo^
	pPin = (CBSchPin*)plistPin->GetAt(pos);
	plistPin->RemoveAt(pos);

	/****** `Version 0.63a ******/
//	lstrcpy(sz,pPin->m_strPartNum);
//	lstrcat(sz,".");
//	lstrcat(sz,pPin->m_strPinNum);
//	s_slPinName.AddTail(sz);

	/****** Version 0.64 ******/
	AddToPinNameList(pPin->m_strPartNum,pPin->m_strPinNum);

	
	//s̈ʒu擾B
	pPoint = new CPoint;
	*pPoint = pPin->m_point;
	//sʒuW̃Xgɓo^B
	s_listNewPoint.AddTail((void*)pPoint);
	//s̐M擾āAׂĐVKM̃Xgɓo^B
	pos=pPin->m_listSigName.GetHeadPosition();
	while(pos){
		LPCSTR psz=pPin->m_listSigName.GetNext(pos);
		s_slNewSignalName.AddTail(psz);
	}
	//s̎̂
	delete pPin;

	
	BOOL fDone = TRUE;
	while(fDone){
		//TRACE("NetList1() Main loop\n");
		fDone = FALSE;
		while(1){//MJԂ
			pos = s_slNewSignalName.GetHeadPosition();
			if(!pos) break;
			fDone = TRUE;
			CString strSignal = s_slNewSignalName.GetAt(pos); 
			s_slNewSignalName.RemoveAt(pos);//VKM폜
			s_slSignalName.AddTail(strSignal);//ݐMɒǉ

			//MŃsB
			pos = plistPin->GetHeadPosition();
			while(pos){//MɂđSẴsXL
				BOOL fHit=FALSE;
				posOld=pos;
				pPin = (CBSchPin*)plistPin->GetNext(pos);
				pos2=pPin->m_listSigName.GetHeadPosition();
				while(pos2){//sMoČ̐MƔr
					LPCSTR szSigNamePin=pPin->m_listSigName.GetNext(pos2);
					if(lstrcmp(strSignal,szSigNamePin)==0){
						fHit=TRUE;
						break;
					}
				}
				if(fHit){//sM̐MƈvB
					plistPin->RemoveAt(posOld);//s̃Xg͂Bî͎cj

					/****** `Version 0.63a ******/
					//lstrcpy(sz,pPin->m_strPartNum);
					//lstrcat(sz,".");
					//lstrcat(sz,pPin->m_strPinNum);
					//s_slPinName.AddTail(sz);

					/****** Version 0.64 ******/
					AddToPinNameList(pPin->m_strPartNum,pPin->m_strPinNum);

					

					//ʒuWȂ...
					if(IsNewPoint(&pPin->m_point)){
						pPoint = new CPoint;
						*pPoint = pPin->m_point;
						//sʒuW̃Xgɓo^B
						s_listPoint.AddTail((void*)pPoint);
					}
					//s̐M擾āA̐MM̃Xgɓo^B
					pos2=pPin->m_listSigName.GetHeadPosition();
					while(pos2){
						LPCSTR psz=pPin->m_listSigName.GetNext(pos2);
						if(IsNewSignalName(psz))s_slNewSignalName.AddTail(psz);
					}
					delete pPin;//s̎̂
				}// ܂ *** if(fHit){//sM̐MƈvB
			}// ܂ *** while(pos){//MɂđSẴsXL
	

			pos = plistWire->GetHeadPosition();
			//MŐB
			while(pos){//MɂđSĂ̐XL
				BOOL fHit=FALSE;
				posOld=pos;
				pWire = (CBSchWire*)plistWire->GetNext(pos);
				pos2=pWire->m_listSigName.GetHeadPosition();
				while(pos2){//sMoČ̐MƔr
					LPCSTR szSigNamePin=pPin->m_listSigName.GetNext(pos2);
					if(lstrcmp(strSignal,szSigNamePin)==0){
						fHit=TRUE;
						break;
					}
				}
				if(fHit){//M̐MƈvB
					plistWire->RemoveAt(posOld);//s̃Xg͂Bî͎cj
					//[_ʒuWȂW̃Xgɓo^B
					CPoint pt;
					pt=pWire->GetPoint();
					if(IsNewPoint(&pt)){
						pPoint = new CPoint;
						*pPoint = pt;
						s_listNewPoint.AddTail((void*)pPoint);
					}
					pt=pWire->GetPoint1();
					if(IsNewPoint(&pt)){
						pPoint = new CPoint;
						*pPoint = pt;
						s_listNewPoint.AddTail((void*)pPoint);
					}

					//̐M擾āA̐MM̃Xgɓo^B
					pos2=pWire->m_listSigName.GetHeadPosition();
					while(pos2){
						LPCSTR psz=pPin->m_listSigName.GetNext(pos2);
						if(IsNewSignalName(psz))s_slNewSignalName.AddTail(psz);
					}
					delete pWire;//̎̂
				}// ܂ *** if(fHit){//M̐MƈvB
			}// ܂ *** while(pos){//MɂđSĂ̐XL
		}// ܂ *** while(1){//MJԂ


	
		while(1){//WJԂ
			pos = s_listNewPoint.GetHeadPosition();
			if(!pos) break;
			fDone = TRUE;
			CPoint* pPoint0 =(CPoint*)s_listNewPoint.GetAt(pos); 
			s_listNewPoint.RemoveAt(pos);//VKM폜
			s_listPoint.AddTail((void*)pPoint0);//ݐMɒǉ

			//WŃsB
			pos = plistPin->GetHeadPosition();
			while(pos){//WɂđSẴsXL
				posOld=pos;
				pPin = (CBSchPin*)plistPin->GetNext(pos);
				if(*pPoint0 == pPin->m_point){//s̍W̍WƈvB
					plistPin->RemoveAt(posOld);//s̃Xg͂Bî͎cj
					//lstrcpy(sz,pPin->m_strPartNum);
					//lstrcat(sz,".");
					//lstrcat(sz,pPin->m_strPinNum);
					//s_slPinName.AddTail(sz);
					/****** Version 0.64 ******/
					AddToPinNameList(pPin->m_strPartNum,pPin->m_strPinNum);
					
					//s̐M擾āA̐MM̃Xgɓo^B
					pos2=pPin->m_listSigName.GetHeadPosition();
					while(pos2){
						LPCSTR psz=pPin->m_listSigName.GetNext(pos2);
						if(IsNewSignalName(psz))s_slNewSignalName.AddTail(psz);
					}
					delete pPin;//s̎̂
				}// ܂ *** if(*pPoint0 == pPin->m_point){//s̍W̍WƈvB
			}// ܂ *** //WɂđSẴsXL


			//WŐB
			pos = plistWire->GetHeadPosition();
			while(pos){//WőSĂ̐XL
				int nHit=0;
				posOld=pos;
				pWire = (CBSchWire*)plistWire->GetNext(pos);
				CPoint p0,p1;
				p0=pWire->GetPoint();
				p1=pWire->GetPoint1();

				if(*pPoint0 == p0) nHit=1;
				else if(*pPoint0 == p1) nHit=2;

				if(nHit){//̍W̍WƈvB
					plistWire->RemoveAt(posOld);//s̃Xg͂Bî͎cj
					//[_ʒuWȂW̃Xgɓo^B
					if(nHit==2){
						if(IsNewPoint(&p0)){
							pPoint = new CPoint;
							*pPoint = p0;
							s_listNewPoint.AddTail((void*)pPoint);
						}
					}else{
						if(IsNewPoint(&p1)){
							pPoint = new CPoint;
							*pPoint = p1;
							s_listNewPoint.AddTail((void*)pPoint);
						}
					}

					//̐M擾āA̐MM̃Xgɓo^B
					pos2=pWire->m_listSigName.GetHeadPosition();
					while(pos2){
						LPCSTR psz=pPin->m_listSigName.GetNext(pos2);
						if(IsNewSignalName(psz))s_slNewSignalName.AddTail(psz);
					}
					delete pWire;//̎̂
				}// ܂ *** if(fHit){//M̐MƈvB
			}// ܂ *** while(pos){//MɂđSĂ̐XL
		}// ܂ *** while(1){//WJԂ
	}//܂ *** while(fDone){
	return TRUE;
}

//iXg̏o
BOOL OutputPackages(CPtrList* plistPart,CStdioFile* pfileOutput)
{
	CStringList listNum;
	POSITION pos;
	POSITION pos2;
	CBSchPart* pPart;
	LPCSTR psz;
	char sz[128];
	pos=plistPart->GetHeadPosition();
	while(pos){
		pPart=(CBSchPart*)plistPart->GetNext(pos);
		psz=pPart->GetNum();
		pos2=listNum.GetHeadPosition();
		BOOL fNew=TRUE;
		while(pos2){
			if(listNum.GetNext(pos2) == psz){
				fNew = FALSE;
				break;
			}
		}
		if(fNew){
			listNum.AddTail(psz);
			wsprintf(sz,"! %s; %s\n",pPart->GetName(),psz);
			pfileOutput->WriteString(sz);
		}
	}
	return TRUE;
}


BOOL CreateNetList(LPCSTR pszSrc,LPCSTR pszNetList,BOOL fUseIni,
				   BOOL fUsePWRSYM,BOOL fCSVMODE)
{
	int nResult;
	CString str;
	POSITION pos;
	char sz[64];
	char sz2[128];

	
	//Cut@C̓ǂݍ
	if(!g_ReadLibrary(pszSrc,fUseIni,fUsePWRSYM)){
		AfxMessageBox(IDS_LIBRARYREADERROR,MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
	//f[^t@C̓ǂݍ
	CBSchData bschdata;
	nResult=bschdata.ReadData(pszSrc);
	switch(nResult){
	case CBSchData::openerror:
		AfxFormatString1(str,IDS_FILEOPENERROR,pszSrc); 
		AfxMessageBox(str,MB_ICONEXCLAMATION|MB_OK);
		g_FreeLibrary();
		return FALSE;
	case CBSchData::dataerror:
		AfxFormatString1(str,IDS_FILEREADERROR,pszSrc); 
		AfxMessageBox(str,MB_ICONEXCLAMATION|MB_OK);
		g_FreeLibrary();
		return FALSE;
	case CBSchData::libraryerror:
		AfxMessageBox(IDS_LIBRARYERROR,MB_ICONEXCLAMATION|MB_OK);
		g_FreeLibrary();
		return FALSE;
	}


	CStdioFile fileOutput;
	if(fileOutput.Open(pszNetList,
					CFile::modeCreate|CFile::modeWrite|
					CFile::typeText|CFile::shareExclusive
				)==FALSE)
	{//t@C̃I[vɎs
		CString rMsg;
		AfxFormatString1(rMsg,IDS_FILEOPENERROR,pszNetList);	//bZ[W 
		AfxMessageBox(rMsg,MB_ICONEXCLAMATION|MB_OK);							//bZ[W{bNX\
		g_FreeLibrary();
		return FALSE;
	}



	//O
	//dĂA
	s_JointWire(&(bschdata.m_listWire));
	TRACE("JOINT WIRE-%d\n",bschdata.m_listWire.GetCount());
	//ڑ_ŕ
	s_DivideWire(&(bschdata.m_listWire),&(bschdata.m_listJunction));
	TRACE("DIVIDE WIRE-%d\n",bschdata.m_listWire.GetCount());
	//iԍŕiقȂ镔i폜
	s_DeleteDuplicatePart(&(bschdata.m_listPart));

	//iXg̏o
	if(!fCSVMODE){
		fileOutput.WriteString("$PACKAGES\n");
		OutputPackages(&(bschdata.m_listPart),&fileOutput);
	}

#ifdef _DEBUG
//	bschdata.WriteData(pszSrc);
#endif
	//Lȕĩs񋓂
	s_EnumPin(&(bschdata.m_listPart),&(bschdata.m_listPin));
	//diɐƃsɐ
	NameFromPowerPart(&(bschdata.m_listWire),&(bschdata.m_listPin),&(bschdata.m_listPowerPart));
	//^Oɐƃsɐǉ
	NameFromTag(&(bschdata.m_listWire),&(bschdata.m_listPin),&(bschdata.m_listTag));
	//xɐɖOǉ
	NameFromLabel(&(bschdata.m_listWire),&(bschdata.m_listLabel));
	
	if(!fCSVMODE){
		fileOutput.WriteString("$NETS\n");
	}
	int nNet=1;
	int nOutPin;
	while(1){
		s_ClearLocalList();
		if(!NetList1(&(bschdata.m_listWire),&(bschdata.m_listPin))) break;
		//if(s_slPinName.GetCount()<2) continue;
		if(s_listPinName.GetCount()<2) continue;

		pos = s_slSignalName.GetHeadPosition();

		if(!pos) wsprintf(sz2,"N%05d",nNet++);
		else wsprintf(sz2,"%s",s_slSignalName.GetAt(pos));

		if(!fCSVMODE){
			wsprintf(sz,"%s;   ",sz2);
		}else{
			lstrcpy(sz,sz2);
		}

		if(!fCSVMODE){
			fileOutput.WriteString(sz);
		}
		nOutPin=0;
		//pos = s_slPinName.GetHeadPosition();
		pos = s_listPinName.GetHeadPosition();
		while(pos){
			CNLPinName* pPinName=(CNLPinName*)s_listPinName.GetNext(pos);
			if(!fCSVMODE){
				wsprintf(sz2,"%s.%s",pPinName->m_strPartNum,pPinName->m_strPinNum);
				fileOutput.WriteString(sz2);
				nOutPin++;
				if(nOutPin==4 && pos){
					fileOutput.WriteString(" ,\n     ");
					nOutPin=0;
				}else{
					fileOutput.WriteString(" ");
				}
			}else{
				wsprintf(sz2,"\"%s\",\"%s\",\"%s\"\n",
					sz,pPinName->m_strPartNum,pPinName->m_strPinNum);
				fileOutput.WriteString(sz2);
			}
		}
		if(!fCSVMODE){
			if(nOutPin)fileOutput.WriteString("\n");
		}
	}
	if(!fCSVMODE){
		fileOutput.WriteString("$END\n");
	}	
	
	//lbg쐬p̕ϐ
	s_ClearLocalList();

	g_FreeLibrary();
	return TRUE;
}